//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%399D65EE024A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%399D65EE024A.cm

//## begin module%399D65EE024A.cp preserve=no
//## end module%399D65EE024A.cp

//## Module: EinsteinData%399D65EE024A; Package body
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/EinsteinData.cxx

//## begin module%399D65EE024A.additionalIncludes preserve=no
//## end module%399D65EE024A.additionalIncludes

//## begin module%399D65EE024A.includes preserve=yes
//## end module%399D65EE024A.includes

// DataSetBase
#include <XSModel/Data/DataSetBase.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// EinsteinData
#include <XSModel/Data/EinsteinData.h>
// Background
#include <XSModel/Data/BackCorr/Background.h>
//## begin module%399D65EE024A.declarations preserve=no
//## end module%399D65EE024A.declarations

//## begin module%399D65EE024A.additionalDeclarations preserve=yes
//## end module%399D65EE024A.additionalDeclarations


// Class EinsteinData 

EinsteinData::EinsteinData()
  //## begin EinsteinData::EinsteinData%363DDB9902DB_const.hasinit preserve=yes
  : DataSet(), EinsteinIO()
  //## end EinsteinData::EinsteinData%363DDB9902DB_const.hasinit
  //## begin EinsteinData::EinsteinData%363DDB9902DB_const.initialization preserve=yes
  //## end EinsteinData::EinsteinData%363DDB9902DB_const.initialization
{
  //## begin EinsteinData::EinsteinData%363DDB9902DB_const.body preserve=yes
  //## end EinsteinData::EinsteinData%363DDB9902DB_const.body
}

EinsteinData::EinsteinData(const EinsteinData &right)
  //## begin EinsteinData::EinsteinData%363DDB9902DB_copy.hasinit preserve=yes
  : DataSet(right), EinsteinIO(right)
  //## end EinsteinData::EinsteinData%363DDB9902DB_copy.hasinit
  //## begin EinsteinData::EinsteinData%363DDB9902DB_copy.initialization preserve=yes
  //## end EinsteinData::EinsteinData%363DDB9902DB_copy.initialization
{
  //## begin EinsteinData::EinsteinData%363DDB9902DB_copy.body preserve=yes
  //## end EinsteinData::EinsteinData%363DDB9902DB_copy.body
}


EinsteinData::~EinsteinData()
{
  //## begin EinsteinData::~EinsteinData%363DDB9902DB_dest.body preserve=yes
  //## end EinsteinData::~EinsteinData%363DDB9902DB_dest.body
}



//## Other Operations (implementation)
EinsteinData* EinsteinData::clone () const
{
  //## begin EinsteinData::clone%39940FAC00BF.body preserve=yes
  //## end EinsteinData::clone%39940FAC00BF.body

  return new EinsteinData(*this);
}

bool EinsteinData::fileFormat (const string& fileName, XspecDataIO::DataType type)
{
  //## begin EinsteinData::fileFormat%399D655403BE.body preserve=yes
  // oh, the joys of multiple inheritance!
  // fileFormat is virtual both in RegisteredFormat and EinsteinIO.
  // the default implementation for EinsteinIO::fileFormat returns
  // true for Einstein format spectrum files (meaning, spectrum
  // background and correction). For those objects we can just call that
  // EinsteinIO default implementation and we're done.
  return EinsteinIO::fileFormat(fileName);
  //## end EinsteinData::fileFormat%399D655403BE.body
}

void EinsteinData::defineArrays ()
{
  //## begin EinsteinData::defineArrays%39F7369F0265.body preserve=yes
  //## end EinsteinData::defineArrays%39F7369F0265.body
}

void EinsteinData::groupQuality ()
{
  //## begin EinsteinData::groupQuality%39FEF2AA0376.body preserve=yes
  //## end EinsteinData::groupQuality%39FEF2AA0376.body
}

void EinsteinData::setArrays (size_t row)
{
  //## begin EinsteinData::setArrays%3A01C403019C.body preserve=yes
  //## end EinsteinData::setArrays%3A01C403019C.body
}

void EinsteinData::scaleArrays (size_t row)
{
  //## begin EinsteinData::scaleArrays%3A01E1F501B3.body preserve=yes
  //## end EinsteinData::scaleArrays%3A01E1F501B3.body
}

void EinsteinData::initialize (DataPrototype* proto, DataInputRecord& record)
{
  //## begin EinsteinData::initialize%3A1C112900BB.body preserve=yes
  //## end EinsteinData::initialize%3A1C112900BB.body
}

void EinsteinData::setDescription (size_t spectrumNumber, size_t row)
{
  //## begin EinsteinData::setDescription%3A1C4D8300BD.body preserve=yes
  //## end EinsteinData::setDescription%3A1C4D8300BD.body
}

bool EinsteinData::setAncillaryData (size_t row, int ancRow)
{
  //## begin EinsteinData::setAncillaryData%3A26CF68005B.body preserve=yes
  return true;
  //## end EinsteinData::setAncillaryData%3A26CF68005B.body
}

void EinsteinData::closeSourceFiles ()
{
  //## begin EinsteinData::closeSourceFiles%3A39406902B0.body preserve=yes
  //## end EinsteinData::closeSourceFiles%3A39406902B0.body
}

void EinsteinData::copy (const DataSet& right)
{
  //## begin EinsteinData::copy%3A9578AC004E.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  EinsteinData __temp(static_cast<const EinsteinData&>(right));
  swap(__temp);   
  //## end EinsteinData::copy%3A9578AC004E.body
}

void EinsteinData::Swap (DataSet& right)
{
  //## begin EinsteinData::Swap%3A9578F401F0.body preserve=yes
  EinsteinData&  that = static_cast<EinsteinData&>(right);
  DataSet::Swap(right);
  EinsteinIO::swap(that);
  //## end EinsteinData::Swap%3A9578F401F0.body
}

void EinsteinData::reportResponse (size_t row) const
{
  //## begin EinsteinData::reportResponse%3C07E8D00385.body preserve=yes
  //## end EinsteinData::reportResponse%3C07E8D00385.body
}

void EinsteinData::initializeFake (DataPrototype* proto, FakeDataInputRecord& record)
{
  //## begin EinsteinData::initializeFake%3E89E55B00F6.body preserve=yes
  //## end EinsteinData::initializeFake%3E89E55B00F6.body
}

void EinsteinData::outputData ()
{
  //## begin EinsteinData::outputData%3E9D8C9D0171.body preserve=yes
  //## end EinsteinData::outputData%3E9D8C9D0171.body
}

std::pair<string,size_t>  EinsteinData::getBackCorrLocation (size_t rowNum, bool isCorr) const
{
  //## begin EinsteinData::getBackCorrLocation%3EB968E101EB.body preserve=yes
  return std::pair<string,size_t>(string(),0);
  //## end EinsteinData::getBackCorrLocation%3EB968E101EB.body
}

FakeDataInputRecord::Detectors EinsteinData::getResponseName (size_t rowNum) const
{
  //## begin EinsteinData::getResponseName%47C4857E03D1.body preserve=yes
   return FakeDataInputRecord::Detectors();
  //## end EinsteinData::getResponseName%47C4857E03D1.body
}

FakeDataInputRecord::Arfs EinsteinData::getAncillaryLocation (size_t rowNum, const FakeDataInputRecord::Detectors& respInfo) const
{
  //## begin EinsteinData::getAncillaryLocation%47C4858A00A6.body preserve=yes
   return FakeDataInputRecord::Arfs();
  //## end EinsteinData::getAncillaryLocation%47C4858A00A6.body
}

// Additional Declarations
  //## begin EinsteinData%363DDB9902DB.declarations preserve=yes
  //## end EinsteinData%363DDB9902DB.declarations

//## begin module%399D65EE024A.epilog preserve=yes
//## end module%399D65EE024A.epilog
